\name{anova.tam}
\alias{anova.tam}
\alias{anova.tam.mml}



%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Likelihood Ratio Test for Model Comparisons
}
\description{
This function compares two models estimated \code{tam}
or \code{tam.mml} using a likelihood ratio test.
}
\usage{
\method{anova}{tam}(object,object1,\dots)

\method{anova}{tam.mml}(object,object1,\dots)
}



\arguments{
  \item{object}{
Object of class \code{tam} or \code{tam.mml} 
}
  \item{object1}{
Object of class \code{tam} or \code{tam.mml} 
}
\item{\dots}{Further arguments to be passed}
}


%\details{
%%  ~~ If necessary, more details than the description above ~~
%}


\value{
A data frame containing the likelihood ratio test statistic and
information criteria.
}


%\references{
%% ~put references to the literature/web site here ~
%}
%\author{
%% Alexander Robitzsch
%}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}

\examples{
#############################################################################
# EXAMPLE 1: Dichotomous data sim.rasch - 1PL vs. 2PL model
#############################################################################
	
data(sim.rasch)
# 1PL estimation
mod1 <- tam.mml(resp=sim.rasch) 
# 2PL estimation
mod2 <- tam.mml.2pl(resp=sim.rasch , irtmodel="2PL") 
# Model comparison
anova( mod1 , mod2 )
## > anova( mod1 , mod2 )
##     Model   loglike Deviance Npars      AIC      BIC    Chisq df       p
## 1 Model 1 -42077.88 84155.77    41 84237.77 84467.40 54.05078 39 0.05508
## 2 Model 2 -42050.86 84101.72    80 84261.72 84709.79       NA NA      NA

\dontrun{
#############################################################################
# EXAMPLE 2: Dataset reading (sirt package): 1- vs. 2-dimensional model
#############################################################################

data(data.read,package="sirt")

# 1-dimensional model
mod1 <- tam.mml.2pl(resp= data.read ) 
# 2-dimensional model
mod2 <- tam.fa(resp= data.read , irtmodel="efa" , nfactors=2 ,
        control=list(maxiter=150) ) 

# Model comparison
anova( mod1 , mod2 )
##       Model   loglike Deviance Npars      AIC      BIC    Chisq df  p
##   1 Model 1 -1954.888 3909.777    24 3957.777 4048.809 76.66491 11  0
##   2 Model 2 -1916.556 3833.112    35 3903.112 4035.867       NA NA NA
}
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{Likelihood ratio test}
\keyword{anova}
%%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
